/* Example of usage & tester for gostciph.dll, (c) 2002 nickk */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "gostciph.h"

#pragma library("gostciph")

int
main(void)
{
	unsigned char ctx[132];
	unsigned char key[32];
	unsigned char plain[40], cipher[40], cipher1[40];
	unsigned char iv[8], iv1[8];
	char message[1024];
	int i, j, num = 0;

	printf("GOST 21847-89 testing.\n");

	for (i = 0; i < 1000; i++) 
	{
		memset(key, 0, sizeof(key));
		sprintf(message, "Round %d\n", i);
		GOST_hashupdate(message, strlen(message), ctx);
		GOST_hashfinal(key, ctx);

		for (j = 0; j < 10; j++)
		{
			((unsigned long *)plain)[j] = rand();
		}
		((unsigned long *)iv)[0] = rand();
		((unsigned long *)iv)[1] = rand();
		memcpy(iv1, iv, sizeof(iv));

		printf("%3d\r", i);
		fflush(stdout);

		GOST_blockencrypt(plain, cipher, key);
		GOST_blockdecrypt(cipher, cipher, key);
		for (j=0; j < 8; j++)
		{
			if (plain[j] != cipher[j]) 
			{
				fprintf(stderr, "\n%d: Error in ECB mode at %d\n", i, j);
				return 1;
			}
		}

		GOST_cbcencrypt(plain, cipher, 40, iv, key);
		memcpy(iv, iv1, sizeof(iv));
		GOST_cbcdecrypt(cipher, cipher, 40, iv, key);
		for (j=0; j < sizeof(plain); j++)
		{
			if (plain[j] != cipher[j]) 
			{
				fprintf(stderr, "\n%d: Error in CBC mode at %d\n", i, j);
				return 1;
			}
		}

		num = 0;
		memcpy(iv, iv1, sizeof(iv));
		GOST_cfbencrypt(plain, cipher, sizeof(plain), iv, &num, key);
		memcpy(iv, iv1, sizeof(iv));
		GOST_cfbdecrypt(cipher, cipher, sizeof(plain), iv, &num, key);
		for (j=0; j < sizeof(plain); j++)
		{
			if (plain[j] != cipher[j]) 
			{
				fprintf(stderr, "\n%d: Error in CFB mode at %d\n", i, j);
				return 1;
			}
		}

		num = 0;
		memcpy(iv, iv1, sizeof(iv));
		GOST_ofbencrypt(plain, cipher, sizeof(plain), iv, &num, key);
		memcpy(iv, iv1, sizeof(iv));
		GOST_ofbdecrypt(cipher, cipher, sizeof(plain), iv, &num, key);
		for (j=0; j < sizeof(plain); j++)
		{
			if (plain[j] != cipher[j]) 
			{
				fprintf(stderr, "\n%d: Error in OFB mode at %d\n", i, j);
				return 1;
			}
		}

	}
	printf("\nOk.\n");
	return 0;
}
